class A {
  constructor() {}

  // 使用泛型和类构造函数签名来推断返回的类型
  static render<T extends new (...args: any[]) => any>(this: T, el: string | HTMLDivElement): InstanceType<T> {
    return new this();
  }
}

class B extends A {
  constructor() {
    super();
  }
}

const a = A.render('div');
const b = B.render('div');

// type a == A
// type b == B
